/**
 * Performs the combination itself
 */

package xorpads;

import java.io.*;

public class XorPads {
    /* Deliver one portion */
    static public byte[] unpad(DataInputStream[] pads,int portionSize)
        throws IOException {
        /* the buffer */
        byte[] buffer = new byte[portionSize];

        /* init with the first data portion */
        pads[0].readFully(buffer);

        /* xor with the rest */
        byte[] inBuffer = new byte[portionSize];
        for(int padNumber = 1; padNumber<pads.length; padNumber++) {
            pads[padNumber].readFully(inBuffer);
            for(int i=0; i<buffer.length; i++) {
                buffer[i] ^= inBuffer[i];
            }
        }

        /* return the requested byte array */
        return buffer;
    }
}
